# MySQLCollector [![Build Status](https://travis-ci.org/swapbytes/mysqlcollector.svg?branch=master)](https://travis-ci.org/swapbytes/mysqlcollector) [![Gem Version](https://badge.fury.io/rb/mysqlcollector.svg)](https://badge.fury.io/rb/mysqlcollector) [![Coverage Status](https://coveralls.io/repos/github/swapbytes/mysqlcollector/badge.svg?branch=master)](https://coveralls.io/github/swapbytes/mysqlcollector?branch=master)

Ruby GEM to collect MySQL Metrics and send them to InfluxDB. It's a fast and easy
implementation.

## Requirements

### Client

Where it's run MySQLCollector.

- Ruby 1.9.3
- MySQL 5.x

### Server

- InfluxDB
- Grafana

## Install

**MySQLCollector** installation is pretty standard:


```bash
$ [sudo] gem install mysqlcollector
```

Create a user and database on MySQL:

```sql
mysql> GRANT REPLICATION CLIENT, PROCESS ON *.*
       TO 'mysqlcollector'@'%' IDENTIFIED BY 'mysqlcollector';
mysql> GRANT SELECT ON performance_schema.* TO 'mysqlcollector'@'%';
```

Create a user and database on InfluxDB:

```sql
> CREATE USER mysqlcollector WITH PASSWORD 'mysqlcollector';
> CREATE DATABASE mysqlcollector;
```

To generate a JSON template for Grafana:

```bash
$ mysqlcollector --template > grafana_mysql.json
```

For more help as import template, please see the [doc of grafana](http://docs.grafana.org/reference/export_import/).

## Basic Usage

For this case, InfluxDB and Grafana running in your local docker, try:

```bash
$ mysqlcollector --mysql-host 192.168.99.100 \
                 --influx-host 192.168.99.100
```

#### Daemonize

You can daemonize this tool, and send new metric every 30 seconds:

```bash
$ mysqlcollector --mysql-host 192.168.99.100 \
                 --influx-host 192.168.99.100 \
                 --daemonize
```

#### Debuging

```bash
$ mysqlcollector --mysql-host 192.168.99.100 \
                 --influx-host 192.168.99.100 \
                 --debug
```

## Warning

1. Do not use this tool in production before testing it.
2. Please, use when do you need.
3. The author is NOT responsible for misuse use of this tool.

## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request
